## mingw-w64-quantum-espresso-7.5-1.src.tar.zst

=== EPW/CMakeLists.txt ===
set(sources
    src/input.f90
    src/ep_constants.f90
    src/global_var.f90
    src/io/io_var.f90
    src/bloch2wannier.f90
    src/utilities/low_lvl.f90
    src/utilities/parallelism.f90
    src/longrange.f90
    src/io/io.f90
    src/io/io_transport.f90
    src/io/io_selfen.f90
    src/wigner.f90
    src/wannier2bloch.f90
    src/wannier2bloch_opt.f90
    src/cumulant.f90
    src/close.f90
    src/printing.f90
    src/utilities/kfold.f90
    src/utilities/bzgrid.f90
    src/io/io_supercond.f90
    src/utilities/utilities.f90
    src/supercond_common.f90
    src/supercond_vertex.f90
    src/supercond.f90
    src/supercond_iso.f90
    src/supercond_aniso.f90
    src/supercond_coul.f90
    src/utilities/sparse_ir.f90
    src/io/io_sparse_ir.f90
    src/stop.f90
    src/transport_mag.f90
    src/utilities/symmetry.f90
    src/transport_legacy.f90
    src/transport.f90
    src/pw2wan.f90
    src/wannierization.f90
    src/indabs.f90
    src/io/io_indabs.f90
    src/utilities/bcast_input.f90
    src/io/io_ahc.f90
    src/dvqpsi.f90
    src/ep_coarse.f90
    src/ep_coarse_unfolding.f90
    src/supercond_driver.f90
    src/selfen.f90
    src/spectral.f90
    src/wannier.f90
    src/use_wannier.f90
    src/init.f90
    src/readin.f90
    src/setups.f90
    src/summaries.f90
    src/wann_common.f90
    src/polaron.f90
    src/qdabs.f90
    src/wfpt.f90
    src/exphonon.f90
    src/expolaron.f90
    src/utilities/screening.f90
    src/tdbe_driver.f90
    src/tdbe_mod.f90
    src/tdbe_common.f90
    src/phph.f90
    )

qe_add_library(qe_epw ${sources})
target_link_libraries(
    qe_epw
    PRIVATE qe_wannier90
            qe_modules
            qe_lr_modules
            qe_phonon_ph
            qe_pw
            qe_mpi_fortran
            qe_upflib
            qe_fftx
            qe_elpa
            qe_xclib)

###########################################################
# epw.x
###########################################################
set(sources src/epw.f90)
qe_add_executable(qe_epw_exe ${sources})
set_target_properties(qe_epw_exe PROPERTIES OUTPUT_NAME epw.x)
target_link_libraries(qe_epw_exe PRIVATE qe_modules qe_pw qe_fftx qe_epw qe_upflib)

###########################################################
# nscf2supercond.x
###########################################################
set(sources src/utilities/nscf2supercond.f90)
qe_add_executable(qe_epw_nscf2supercond_exe ${sources})
set_target_properties(qe_epw_nscf2supercond_exe PROPERTIES OUTPUT_NAME nscf2supercond.x)
target_link_libraries(qe_epw_nscf2supercond_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################
# ZG.x
###########################################################
set(sources ZG/src/ZG.f90)
qe_add_executable(qe_zg_exe ${sources})
set_target_properties(qe_zg_exe PROPERTIES OUTPUT_NAME ZG.x)
target_link_libraries(qe_zg_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# disca.x
###########################################################
set(sources ZG/src/disca.f90)
qe_add_executable(qe_zg_disca_exe ${sources})
set_target_properties(qe_zg_disca_exe PROPERTIES OUTPUT_NAME disca.x)
target_link_libraries(qe_zg_disca_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# pp_disca.x
###########################################################
set(sources ZG/src/pp_disca.f90)
qe_add_executable(qe_zg_pp_disca_exe ${sources})
set_target_properties(qe_zg_pp_disca_exe PROPERTIES OUTPUT_NAME pp_disca.x)
target_link_libraries(qe_zg_pp_disca_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# bands_unfold.x
###########################################################
set(src_bands_unfold_x ZG/src/bands_unfold.f90)
qe_add_executable(qe_zg_bands_unfold_exe ${sources})
set_target_properties(qe_zg_bands_unfold_exe PROPERTIES OUTPUT_NAME bands_unfold.x)
target_link_libraries(qe_zg_bands_unfold_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################
# pp_spctrlfn.x
###########################################################
set(sources ZG/src/pp_spctrlfn.f90)
qe_add_executable(qe_zg_pp_spctrlfn_exe ${sources})
set_target_properties(qe_zg_pp_spctrlfn_exe PROPERTIES OUTPUT_NAME pp_spctrlfn.x)
target_link_libraries(qe_zg_pp_spctrlfn_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# epsilon_Gaus.x
###########################################################
set(src_epsilon_Gaus_x ZG/src/epsilon_Gaus.f90)
qe_add_executable(qe_zg_epsilon_Gaus_exe ${sources})
set_target_properties(qe_zg_epsilon_Gaus_exe PROPERTIES OUTPUT_NAME epsilon_Gaus.x)
target_link_libraries(qe_zg_epsilon_Gaus_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################

qe_install_targets(
    # Libraries
    qe_epw
    # Exacutables
    qe_epw_exe
    qe_epw_nscf2supercond_exe
    qe_zg_exe
    qe_zg_disca_exe
    qe_zg_pp_disca_exe
    qe_zg_bands_unfold_exe
    qe_zg_pp_spctrlfn_exe
    qe_zg_epsilon_Gaus_exe)

install(PROGRAMS bin/pp.py TYPE BIN RENAME epw_pp.py)

add_custom_target(epw
    DEPENDS
        qe_epw_exe
        qe_epw_nscf2supercond_exe
        qe_zg_exe
        qe_zg_disca_exe
        qe_zg_pp_disca_exe
        qe_zg_bands_unfold_exe
        qe_zg_pp_spctrlfn_exe
        qe_zg_epsilon_Gaus_exe
    COMMENT
        "electron-Phonon Coupling with wannier functions")

=== KS_Solvers/CMakeLists.txt ===
set(ks_headers
  ks_solver_interfaces.h)
set (ks_include_dir ${CMAKE_CURRENT_BINARY_DIR}/include)
#FIXME maybe better to move this part to an helper function 
foreach (in_h ${ks_headers})
  get_filename_component(in_h_basename ${in_h} NAME_WE)
  set (out_h "${ks_include_dir}/${in_h_basename}.fh")
  qe_preprocess_source("${CMAKE_CURRENT_SOURCE_DIR}/${in_h}" ${out_h})
  list (APPEND ks_out_headers ${out_h})
endforeach()
add_custom_target(qe_ks_headers 
  DEPENDS ${ks_out_headers}
  VERBATIM )

set(src_davidson
    Davidson_RCI/david_rci.f90
    Davidson/cegterg.f90
    Davidson/regterg.f90
    # GPU
    Davidson/regterg_gpu.f90
    Davidson/cegterg_gpu.f90)
qe_enable_cuda_fortran("${src_davidson}")

set(src_davidson_rci
    Davidson_RCI/david_rci.f90)

set(src_cg
    CG/ccgdiagg.f90
    CG/rcgdiagg.f90)
qe_enable_cuda_fortran("${src_cg}")

set(src_dense
    DENSE/rotate_HSpsi_gamma.f90
    DENSE/rotate_HSpsi_k.f90
    DENSE/rotate_wfc_gamma.f90
    DENSE/rotate_wfc_k.f90 
    DENSE/rotate_xpsi_k.f90
    DENSE/rotate_xpsi_gamma.f90
    DENSE/gram_schmidt_k.f90
    DENSE/gram_schmidt_gamma.f90
    DENSE/rotate_driver.f90)
qe_enable_cuda_fortran("${src_dense}")

set(src_paro
    ParO/bpcg_gamma.f90
    ParO/bpcg_k.f90
    ParO/paro_gamma.f90
    ParO/pcg_gamma.f90
    ParO/paro_k.f90
    ParO/pcg_k.f90
    ParO/paro_gamma_new.f90
    ParO/paro_k_new.f90)
qe_enable_cuda_fortran("${src_paro}")

set(src_rmmdiis
    RMM/crmmdiagg.f90 
    RMM/rrmmdiagg.f90) 
    qe_enable_cuda_fortran("${src_rmmdiis}")

qe_add_library(qe_kssolver_davidson ${src_davidson})
target_link_libraries(qe_kssolver_davidson
    PRIVATE
        qe_device_lapack
        qe_openacc_fortran
        qe_openmp_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_davidsonrci ${src_davidson_rci})
target_link_libraries(qe_kssolver_davidsonrci
    PRIVATE
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_cg ${src_cg})
target_link_libraries(qe_kssolver_cg
    PRIVATE
        qe_lax
        qe_openacc_fortran
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_dense ${src_dense})
target_link_libraries(qe_kssolver_dense
    PRIVATE
        qe_openacc_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)
target_include_directories(qe_kssolver_dense
  PUBLIC
    $<BUILD_INTERFACE:${ks_include_dir}>
    $<INSTALL_INTERFACE:include/qe>
)
set_target_properties(qe_kssolver_dense
  PROPERTIES PUBLIC_HEADER ${ks_out_headers}
)
add_dependencies(qe_kssolver_dense qe_ks_headers)

qe_add_library(qe_kssolver_paro ${src_paro})
target_link_libraries(qe_kssolver_paro
    PRIVATE 
        qe_device_lapack
        qe_openacc_fortran
        qe_kssolver_dense
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_rmmdiis ${src_rmmdiis})
target_link_libraries(qe_kssolver_rmmdiis
    PRIVATE
	qe_lax
        qe_openacc_fortran
        qe_utilx
	qe_devxlib
        qe_mpi_fortran )  

###########################################################

qe_install_targets(
    qe_kssolver_davidson
    qe_kssolver_davidsonrci
    qe_kssolver_cg
    qe_kssolver_paro
    qe_kssolver_dense
    qe_kssolver_rmmdiis)

=== KS_Solvers/Makefile ===
# Makefile for  KS_Solvers
include ../make.inc

# the following directive prevents execution of this makefile in parallel
# Problem is, libks_solvers.a depends upon all libdavid libcg etc, but if
# those dependencies are added explicitly to libks_solvers.a, the library
# is relinked every time, forcing relinking of many executables; if not, 
# parallel make may execute libks_solvers.a before all other lib* complete 
.NOTPARALLEL :

default: all

all: libdavid_rci libdavid libcg libparo librmm libdense libnewsolver libks_solvers.a ks_solver_interfaces.fh

ALLOBJS = \
Davidson_RCI/david_rci.o \
Davidson/cegterg.o \
Davidson/regterg.o \
CG/ccgdiagg.o \
CG/rcgdiagg.o \
ParO/bpcg_gamma.o \
ParO/bpcg_k.o \
ParO/paro_gamma.o \
ParO/pcg_gamma.o \
ParO/paro_k.o \
ParO/pcg_k.o \
ParO/paro_gamma_new.o \
ParO/paro_k_new.o \
DENSE/rotate_HSpsi_gamma.o \
DENSE/rotate_HSpsi_k.o \
DENSE/rotate_wfc_gamma.o \
DENSE/rotate_wfc_k.o \
DENSE/rotate_driver.o \
DENSE/gram_schmidt_gamma.o \
DENSE/gram_schmidt_k.o \
DENSE/rotate_xpsi_gamma.o \
DENSE/rotate_xpsi_k.o \
RMM/crmmdiagg.o \
RMM/rrmmdiagg.o


# GPU-related objects
ALLOBJS += \
Davidson/cegterg_gpu.o \
Davidson/regterg_gpu.o

# add here other objects, e.g. ParO/*.o NewSolver/*.o

libks_solvers.a: $(ALLOBJS) 
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@



libdavid_rci : 
	if test -d Davidson_RCI ; then \
	( cd Davidson_RCI ; $(MAKE) all || exit 1 ) ; fi

libdavid : 
	if test -d Davidson ; then \
        ( cd Davidson ; $(MAKE) all || exit 1 ) ; fi

libcg : 
	if test -d CG ; then \
        ( cd CG ; $(MAKE) all || exit 1 ) ; fi

libparo : 
	if test -d ParO ; then \
        ( cd ParO ; $(MAKE) all || exit 1 ) ; fi

librmm : 
	if test -d RMM ; then \
        ( cd RMM ; $(MAKE) all || exit 1 ) ; fi

libdense : 
	if test -d DENSE ; then \
        ( cd DENSE ; $(MAKE) all || exit 1 ) ; fi

librmm :
	if test -d RMM ; then \
        ( cd RMM ; $(MAKE) all || exit 1 ) ; fi

libnewsolver : 
	if test -d NewSolver ; then \
        ( cd NewSolver ; $(MAKE) all || exit 1 ) ; fi

clean : 
	if test -d Davidson_RCI ; then ( cd Davidson_RCI ; $(MAKE) clean ) ; fi
	if test -d Davidson     ; then ( cd Davidson ; $(MAKE) clean ) ; fi
	if test -d CG           ; then ( cd CG ; $(MAKE) clean ) ; fi
	if test -d ParO         ; then ( cd ParO ; $(MAKE) clean ) ; fi
	if test -d RMM          ; then ( cd RMM ; $(MAKE) clean ) ; fi
	if test -d DENSE        ; then ( cd DENSE ; $(MAKE) clean ) ; fi
	if test -d RMM          ; then ( cd RMM ; $(MAKE) clean ) ; fi
	if test -d NewSolver    ; then ( cd NewSolver ; $(MAKE) clean ) ; fi
	rm -f *.fh 
	rm -f libks_solvers.a

=== LR_Modules/Makefile ===
# Makefile for LR_Modules

include ../make.inc

# location of needed modules and included files (if any)
MODFLAGS=$(BASEMOD_FLAGS) $(MOD_FLAG)$(TOPDIR)/PW/src

LR_MODULES = \
adddvscf.o \
adddvhubscf.o \
addusdbec.o \
addusdbec_nc.o \
apply_dpot.o \
apply_dpot_mod.o \
apply_trev.o \
addusldos.o \
adddvepsi_us.o \
addusddenseq.o \
c_bands_ph.o \
cft_wave.o \
cgsolve_all.o \
ccgsolve_all.o \
cg_psi.o \
ccg_psi.o \
c_bands_ph.o \
ch_psi_all.o \
ch_psi_all_complex.o \
Coul_cut_2D_ph.o \
check_q_points_sym.o \
dfpt_tetra_mod.o \
dynmat_sub.o \
h_prec.o \
incdrhoscf.o \
incdrhoscf_nc.o \
dv_of_drho.o \
dgradcorr.o \
dnonloccorr.o \
dv_vdW_DF.o \
dv_rVV10.o \
newdq.o \
non_scf_ph.o \
set_intq_nc.o \
lr_sym_mod.o \
sym_def.o \
psymdvscf.o \
symdvscf.o \
sym_dmag.o \
orthogonalize.o \
setup_nscf.o \
set_dbecsum_nc.o \
set_int3_nc.o \
set_kplusq_nc.o \
smallgq.o \
lr_sm1_psi.o \
lr_addusddens.o \
localdos.o \
setup_dgc.o \
compute_vsgga.o \
setup_dmuxc.o \
setup_nbnd_occ.o \
setup_alpha_pv.o \
set_small_group_of_q.o \
sgam_lr.o \
star_q.o \
setqmod.o \
lr_orthoUwfc.o \
qdipol_cryst.o \
mode_group.o \
mix_pot.o \
lrcom.o \
lr_dot.o \
lr_dot_magnons.o \
lr_nc_mag.o \
lr_two_chem.o\
lanczos_nonhermitian.o \
lanczos_pseudohermitian.o \
lanczos_pseudohermitian_c.o \
lanczos_nonhermitian_c.o \
response_kernels.o \
non_scf_ph.o \
efermi_shift.o

TLDEPS=mods pwlibs

all : liblrmod.a

liblrmod.a: $(LR_MODULES)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== Modules/CMakeLists.txt ===
set(src_modules
    additional_kpoints.f90 
    atomic_wfc_mod.f90
    autopilot.f90 
    ions_nose.f90
    cell_nose.f90
    basic_algebra_routines.f90 
    becmod.f90 
    bfgs_module.f90 
    bspline.f90 
    bz_form.f90 
    cell_base.f90  
    check_stop.f90  
    command_line_options.f90 
    compute_dipole.f90 
    constants.f90 
    constraints_module.f90 
    control_flags.f90 
    coulomb_vcut.f90  
    dist.f90 
    electrons_base.f90 
    environ_base_module.f90
    environment.f90 
    extffield.f90
    fd_gradient.f90 
    fft_base.f90 
    fft_rho.f90 
    fft_wave.f90 
    fsockets.f90 
    funct.f90 
    generate_function.f90 
    gradutils.f90 
    gvecw.f90 
    input_parameters.f90 
    invmat.f90 
    io_files.f90 
    io_global.f90  
    ions_base.f90 
    kind.f90 
    lmdif.f90
    makov_payne.f90
    mdiis.f90 
    mm_dispersion.f90 
    mp_bands.f90 
    mp_exx.f90 
    mp_global.f90 
    mp_images.f90 
    mp_pools.f90 
    mp_wave.f90 
    mp_world.f90 
    noncol.f90 
    open_close_input_file.f90 
    parameters.f90 
    parser.f90 
    plugin_flags.f90 
    plugin_arguments.f90 
    plugin_variables.f90 
    printout_base.f90
    pw_dot.f90 
    qmmm.f90 
    random_numbers.f90 
    read_cards.f90 
    read_input.f90 
    read_namelists.f90 
    read_pseudo.f90 
    recvec.f90 
    recvec_subs.f90 
    run_info.f90 
    space_group.f90 
    set_para_diag.f90 
    set_signal.f90 
    set_vdw_corr.f90 
    copy_order_um_from_xml.f90
    setqf.f90 
    timestep.f90
    tsvdw.f90
    mbdlib.f90
    version.f90 
    wannier_gw.f90
    wannier_new.f90 
    wavefunctions.f90 
    ws_base.f90 
    xc_vdW_DF.f90 
    xc_rVV10.f90 
    io_base.f90 
    qes_types_module.f90 
    qes_libs_module.f90  
    qes_write_module.f90 
    qes_read_module.f90 
    qes_reset_module.f90 
    qes_init_module.f90 
    qes_bcast_module.f90 
    qexsd.f90   
    qexsd_copy.f90   
    qexsd_init.f90   
    qexsd_input.f90 
    hdf5_qe.f90
    qeh5_module.f90
    fox_init_module.f90 
    xsf.f90 
    wyckoff.f90 
    wypos.f90 
    zvscal.f90 
    wave_gauge.f90
    # list of RISM's modules
    allocate_fft_3drism.f90
    chempot.f90
    chempot_lauerism.f90
    closure.f90
    corrdipole_laue.f90
    correctat0_vv.f90
    corrgxy0_laue.f90
    cryst_to_car_2d.f90
    data_structure_3drism.f90
    do_1drism.f90
    do_3drism.f90
    do_lauerism.f90
    eqn_1drism.f90
    eqn_3drism.f90
    eqn_lauedipole.f90
    eqn_lauegxy0.f90
    eqn_lauelong.f90
    eqn_lauerism.f90
    eqn_laueshort.f90
    eqn_lauevoid.f90
    err_rism.f90
    guess_3drism.f90
    init_1drism.f90
    init_3drism.f90
    input_1drism.f90
    input_3drism.f90
    io_rism_xml.f90
    lauefft.f90
    lauefft_subs.f90
    lj_forcefield.f90
    lj_solute.f90
    molecorr_vv.f90
    molebridge_vv.f90
    molecule_const.f90
    molecule_types.f90
    mp_rism.f90
    mp_swap_ax_rism.f90
    normalize_lauerism.f90
    plot_rism.f90
    potential_3drism.f90
    potential_esm.f90
    potential_vv.f90
    print_chempot_3drism.f90
    print_chempot_lauerism.f90
    print_chempot_vv.f90
    print_corr_vv.f90
    print_solvavg.f90
    radfft.f90
    read_mol.f90
    read_solv.f90
    recvec_3drism.f90
    rism.f90
    rism1d_facade.f90
    rism3d_facade.f90
    rms_residual.f90
    scale_fft_3drism.f90
    scale_fft_lauerism.f90
    solute.f90
    solvation_3drism.f90
    solvation_esm.f90
    solvation_force.f90
    solvation_lauerism.f90
    solvation_pbc.f90
    solvation_stress.f90
    solvavg.f90
    solvmol.f90
    summary_1drism.f90
    summary_3drism.f90
    suscept_g0.f90
    suscept_laue.f90
    suscept_laueint.f90
    suscept_vv.f90
    write_rism_type.f90
    xml_io_rism.f90
    # subroutines and functions (not modules) previously found in flib
    atom_weight.f90 
    capital.f90 
    cryst_to_car.f90
    expint.f90 
    generate_k_along_lines.f90 
    more_functionals.f90 
    has_xml.f90 
    inpfile.f90 
    int_to_char.f90 
    latgen.f90 
    linpack.f90 
    matches.f90 
    plot_io.f90 
    radial_gradients.f90 
    rgen.f90 
    recips.f90 
    remove_tot_torque.f90
    sort.f90 
    trimcheck.f90 
    test_input_file.f90 
    date_and_tim.f90 
    volume.f90 
    wgauss.f90 
    w0gauss.f90
    w1gauss.f90
    deviatoric.f90
    # GPU
    random_numbers_gpu.f90)
qe_enable_cuda_fortran("${src_modules}")
qe_add_library(qe_modules ${src_modules})

# subroutines and functions (not modules) previously found in clib
set(src_modules_c
    customize_signals.c
    qmmm_aux.c
    sockets.c)
add_library(qe_modules_c ${src_modules_c})

if(TARGET gitrev)
   add_dependencies(qe_modules gitrev)
   target_compile_definitions(qe_modules PRIVATE HAVE_GITREV)
   target_include_directories(qe_modules PRIVATE ${qe_BINARY_DIR})
endif()

target_link_libraries(qe_modules
    PRIVATE
        qe_device_lapack  
        qe_modules_c
        qe_openmp_fortran
        qe_fftx
        qe_lax
        qe_mpi_fortran
        qe_mbd
        qe_xclib
        qe_devxlib
    PUBLIC
        qe_openacc_fortran
        qe_hdf5_fortran
        qe_upflib
        qe_fox
        qe_utilx
        qe_openacc_fortran)
if(QE_ENABLE_CUDA)
    target_link_libraries(qe_modules
        PRIVATE
            CUDA::curand)
endif()

if(QE_ENABLE_ENVIRON)
    target_link_libraries(qe_modules
    PUBLIC
        qe_environ)
endif()

###########################################################

qe_install_targets(qe_modules qe_modules_c)

=== Modules/Makefile ===
#/a Makefile for Modules

include ../make.inc

# location of needed modules
MODFLAGS=$(BASEMOD_FLAGS)

# list of modules

MODULES = \
additional_kpoints.o \
atomic_wfc_mod.o \
autopilot.o \
ions_nose.o \
cell_nose.o \
basic_algebra_routines.o \
becmod.o \
bfgs_module.o \
bspline.o \
bz_form.o \
cell_base.o  \
check_stop.o  \
command_line_options.o \
compute_dipole.o \
constants.o \
constraints_module.o \
control_flags.o \
coulomb_vcut.o \
dist.o \
electrons_base.o \
environ_base_module.o \
environment.o \
extffield.o \
fd_gradient.o \
fft_base.o \
fft_rho.o \
fft_wave.o \
fsockets.o \
funct.o \
generate_function.o \
gradutils.o \
gvecw.o \
input_parameters.o \
invmat.o \
io_files.o \
io_global.o  \
ions_base.o \
kind.o \
lmdif.o \
makov_payne.o \
mdiis.o \
mm_dispersion.o \
mp_bands.o \
mp_exx.o \
mp_global.o \
mp_images.o \
mp_pools.o \
mp_wave.o \
mp_world.o \
noncol.o \
open_close_input_file.o \
parameters.o \
parser.o \
plugin_flags.o \
plugin_arguments.o \
plugin_variables.o \
printout_base.o \
pw_dot.o \
qmmm.o \
random_numbers.o \
read_cards.o \
read_input.o \
read_namelists.o \
read_pseudo.o \
recvec.o \
recvec_subs.o \
run_info.o \
space_group.o \
set_para_diag.o \
set_signal.o \
set_vdw_corr.o \
copy_order_um_from_xml.o \
setqf.o \
timestep.o\
tsvdw.o\
mbdlib.o\
version.o \
wannier_gw.o\
wannier_new.o \
wavefunctions.o \
ws_base.o \
xc_vdW_DF.o \
xc_rVV10.o \
io_base.o \
qes_types_module.o \
qes_libs_module.o  \
qes_write_module.o \
qes_read_module.o \
qes_reset_module.o \
qes_init_module.o \
qes_bcast_module.o \
qexsd.o   \
qexsd_copy.o   \
qexsd_init.o   \
qexsd_input.o \
hdf5_qe.o\
qeh5_module.o\
fox_init_module.o \
xsf.o \
wyckoff.o \
wypos.o \
zvscal.o \
wave_gauge.o

# list of RISM's modules

RISMLIB = \
allocate_fft_3drism.o \
chempot.o \
chempot_lauerism.o \
closure.o \
corrdipole_laue.o \
correctat0_vv.o \
corrgxy0_laue.o \
cryst_to_car_2d.o \
data_structure_3drism.o \
do_1drism.o \
do_3drism.o \
do_lauerism.o \
eqn_1drism.o \
eqn_3drism.o \
eqn_lauedipole.o \
eqn_lauegxy0.o \
eqn_lauelong.o \
eqn_lauerism.o \
eqn_laueshort.o \
eqn_lauevoid.o \
err_rism.o \
guess_3drism.o \
init_1drism.o \
init_3drism.o \
input_1drism.o \
input_3drism.o \
io_rism_xml.o \
lauefft.o \
lauefft_subs.o \
lj_forcefield.o \
lj_solute.o \
molecorr_vv.o \
molebridge_vv.o \
molecule_const.o \
molecule_types.o \
mp_rism.o \
mp_swap_ax_rism.o \
normalize_lauerism.o \
plot_rism.o \
potential_3drism.o \
potential_esm.o \
potential_vv.o \
print_chempot_3drism.o \
print_chempot_lauerism.o \
print_chempot_vv.o \
print_corr_vv.o \
print_solvavg.o \
radfft.o \
read_mol.o \
read_solv.o \
recvec_3drism.o \
rism.o \
rism1d_facade.o \
rism3d_facade.o \
rms_residual.o \
scale_fft_3drism.o \
scale_fft_lauerism.o \
solute.o \
solvation_3drism.o \
solvation_esm.o \
solvation_force.o \
solvation_lauerism.o \
solvation_pbc.o \
solvation_stress.o \
solvavg.o \
solvmol.o \
summary_1drism.o \
summary_3drism.o \
suscept_g0.o \
suscept_laue.o \
suscept_laueint.o \
suscept_vv.o \
write_rism_type.o \
xml_io_rism.o

# list of subroutines and functions (not modules) previously found in flib/clib

OBJS = \
atom_weight.o \
capital.o \
cryst_to_car.o \
expint.o \
generate_k_along_lines.o \
has_xml.o \
inpfile.o \
int_to_char.o \
latgen.o \
linpack.o \
matches.o \
plot_io.o \
radial_gradients.o \
rgen.o \
recips.o \
remove_tot_torque.o \
sort.o \
trimcheck.o \
test_input_file.o \
date_and_tim.o \
volume.o \
wgauss.o \
w0gauss.o \
w1gauss.o \
deviatoric.o \
customize_signals.o \
qmmm_aux.o \
sockets.o

# GPU versions of modules
MODULES += \
  random_numbers_gpu.o

TLDEPS= libfox libla libfft libutil libmbd librxc libupf

all : libqemod.a

libqemod.a: 	$(MODULES) $(OBJS) $(RISMLIB)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi


clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== PHonon/CMakeLists.txt ===
set(src_ph
    PH/acfdtest.f90
    PH/add_dkmds.f90
    PH/add_for_charges.f90
    PH/add_zstar_ue.f90
    PH/add_zstar_ue_us.f90
    PH/addcore.f90
    PH/dynmat_nlcc.f90
    PH/addnlcc_zstar_eu_us.f90
    PH/addusddens.f90
    PH/addusddens_cond.f90
    PH/addusddense.f90
    PH/addusdynmat.f90
    PH/allocate_part.f90
    PH/allocate_pert.f90
    PH/allocate_phq.f90
    PH/yambo.f90
    PH/bcast_ph_input.f90
    PH/cch_psi_all.f90
    PH/check_if_partial_dyn.f90
    PH/check_initial_status.f90
    PH/check_restart_recover.f90
    PH/clean_pw_ph.f90
    PH/clinear.f90
    PH/close_phq.f90
    PH/compute_alphasum.f90
    PH/compute_alphasum_cond.f90
    PH/compute_becalp.f90
    PH/compute_becsum_ph.f90
    PH/compute_becsum_ph_cond.f90
    PH/compute_drhous.f90
    PH/compute_drhous_nc.f90
    PH/compute_dvloc.f90
    PH/compute_nldyn.f90
    PH/compute_weight.f90
    PH/deallocate_part.f90
    PH/deallocate_phq.f90
    PH/d2ionq.f90
    PH/d2ionq_disp.f90
    PH/d2nsq_bare.f90
    PH/dnsq_bare.f90
    PH/dnsq_orth.f90
    PH/dnsq_orth_set_irr.f90
    PH/dnsq_scf.f90
    PH/davcio_drho.f90
    PH/dfile_autoname.f90
    PH/dfile_star.f90
    PH/dfpt_kernels.f90
    PH/dielec.f90
    PH/do_phonon.f90
    PH/do_q2r.f90
    PH/drho.f90
    PH/drhodv.f90
    PH/drhodvloc.f90
    PH/drhodvnl.f90
    PH/drhodvus.f90
    PH/dvanqq.f90
    PH/dvkb3.f90
    PH/dvpsi_e.f90
    PH/dvqpsi_us.f90
    PH/dvqpsi_us_only.f90
    PH/dyndia.f90
    PH/dynmat0.f90
    PH/dynmat_us.f90
    PH/dynmatcc.f90
    PH/dynmatrix.f90
    PH/dynmat_hub_bare.f90
    PH/dynmat_hub_scf.f90
    PH/dwfc.f90
    PH/dvqhub_barepsi_us.f90
    PH/dvqhub_barepsi_us2.f90
    PH/delta_sphi.f90
    PH/dpsi_orth.f90
    PH/dump_drho.f90
    PH/ep_matrix_element_wannier.f90
    PH/elph.f90
    PH/el_ph_collect.f90
    PH/elphon.f90
    PH/elph_scdft_mod.f90
    PH/elph_tetra_mod.f90
    PH/find_equiv_sites.f90
    PH/find_mode_sym.f90
    PH/find_irrep.f90
    PH/generate_dynamical_matrix_c.f90
    PH/generate_effective_charges_c.f90
    PH/gmressolve_all.f90
    PH/incdrhous.f90
    PH/incdrhous_nc.f90
    PH/initialize_ph.f90
    PH/init_representations.f90
    PH/io_dyn_mat.f90
    PH/io_dyn_mat_old.f90
    PH/io_pattern.f90
    PH/obsolete.f90
    PH/openfilq.f90
    PH/phcom.f90
    PH/ph_restart.f90
    PH/ph_set_upert.f90
    PH/phescf.f90
    PH/phq_init.f90
    PH/phq_readin.f90
    PH/phq_recover.f90
    PH/phq_setup.f90
    PH/phq_summary.f90
    PH/phqscf.f90
    PH/polariz.f90
    PH/print_clock_ph.f90
    PH/prepare_q.f90
    PH/prepare_sym_analysis.f90
    PH/psidspsi.f90
    PH/punch_plot_e.f90
    PH/q_points.f90
    PH/q_points_wannier.f90
    PH/q2qstar_ph.f90
    PH/random_matrix.f90
    PH/read_wfc_rspace_and_fwfft.f90
    PH/rigid.f90
    PH/rotate_dvscf_star.f90
    PH/rotate_and_add_dyn.f90
    PH/rotate_pattern_add.f90
    PH/run_nscf.f90
    PH/save_ph_input.f90
    PH/set_asr_c.f90
    PH/set_drhoc.f90
    PH/set_int12_nc.f90
    PH/set_irr.f90
    PH/set_irr_nosym.f90
    PH/set_irr_sym.f90
    PH/setlocq.f90
    PH/solve_e.f90
    PH/solve_e_fpol.f90
    PH/solve_linter.f90
    PH/stop_ph.f90
    PH/summarize.f90
    PH/sym_and_write_zue.f90
    PH/symdyn_munu.f90
    PH/symdynph_gq.f90
    PH/symm.f90
    PH/symmorphic_or_nzb.f90
    PH/swfc.f90
    PH/sym_dns.f90
    PH/sym_dns_wrapper.f90
    PH/transform_int_so.f90
    PH/transform_int_nc.f90
    PH/transform_alphasum_nc.f90
    PH/transform_alphasum_so.f90
    PH/tra_write_matrix.f90
    PH/trntnsc.f90
    PH/twochem_postproc_dfpt.f90
    PH/write_epsilon_and_zeu.f90
    PH/write_qplot_data.f90
    PH/write_matrix.f90
    PH/write_modes.f90
    PH/write_rec.f90
    PH/write_hub.f90
    PH/zstar_eu.f90
    PH/zstar_eu_us.f90
    # Raman
    PH/psyme2.f90
    PH/chi_test.f90
    PH/dielec_test.f90
    PH/dvpsi_e2.f90
    PH/el_opt.f90
    PH/hdiag.f90
    PH/pcgreen.f90
    PH/ramanm.f90
    PH/syme2.f90
    PH/solve_e2.f90
    PH/solve_e_nscf.f90
    PH/write_ramtns.f90
    PH/d2mxc.f90
    PH/raman_mat.f90
    PH/raman.f90
    PH/dhdrhopsi.f90
    PH/set_dvscf.f90
    PH/dvscf_interpolate.f90
    PH/ahc.f90)
qe_enable_cuda_fortran("${src_ph}")

set(src_phaux
    PH/write_eigenvectors.f90)

set(src_gamma
    Gamma/a_h.f90
    Gamma/cg_readin.f90
    Gamma/cg_setup.f90
    Gamma/cgcom.f90
    Gamma/cgsolve.f90
    Gamma/d2ion.f90
    Gamma/dgradcorr.f90
    Gamma/dielec.f90
    Gamma/drhodv.f90
    Gamma/dvb_cc.f90
    Gamma/dvpsi_e.f90
    Gamma/dvpsi_kb.f90
    Gamma/dyndiar.f90
    Gamma/dynmat_init.f90
    Gamma/dynmatcc.f90
    Gamma/find_equiv_sites.f90
    Gamma/generate_dynamical_matrix.f90
    Gamma/generate_effective_charges.f90
    Gamma/h_h.f90
    Gamma/macro.f90
    Gamma/rhod2vkb.f90
    Gamma/solve_e.f90
    Gamma/solve_ph.f90
    Gamma/writedyn.f90)
qe_enable_cuda_fortran("${src_gamma}")

set(src_fd
    FD/stop_pp.f90)

qe_add_library(qe_phonon_ph ${src_ph})
target_link_libraries(qe_phonon_ph
    PRIVATE
        qe_hdf5_fortran
        qe_openmp_fortran
	qe_openacc_fortran
        qe_mpi_fortran
        qe_pw
        qe_modules
        qe_lr_modules
        qe_upflib
        qe_fftx
        qe_dftd3
        qe_fox
        qe_xclib)

qe_add_library(qe_phonon_phaux ${src_phaux})
target_link_libraries(qe_phonon_phaux
    PRIVATE
        qe_modules
        qe_lr_modules)

qe_add_library(qe_phonon_gamma ${src_gamma})
target_link_libraries(qe_phonon_gamma
    PRIVATE
        qe_pw
        qe_modules
        qe_lr_modules
        qe_upflib
        qe_fftx
        qe_lax
        qe_xclib)

qe_add_library(qe_phonon_fd ${src_fd})
target_link_libraries(qe_phonon_fd
    PRIVATE
        qe_pw
        qe_modules
        qe_lr_modules)

if(QE_ENABLE_CUDA)
    target_link_libraries(qe_modules
        PRIVATE
            CUDA::cublas)
endif()

###########################################################
# ph.x
###########################################################
set(src_phonon_x PH/phonon.f90)
qe_enable_cuda_fortran("${src_phonon_x}")
qe_add_executable(qe_phonon_ph_exe ${src_phonon_x})
set_target_properties(qe_phonon_ph_exe PROPERTIES OUTPUT_NAME ph.x)
target_link_libraries(qe_phonon_ph_exe
    PRIVATE
        qe_openacc_fortran
	qe_openmp_fortran
	qe_mpi_fortran
        qe_pw
        qe_lax
        qe_modules
        qe_phonon_ph)

###########################################################
# dynmat.x
###########################################################
set(src_dynmat_x PH/dynmat.f90)
qe_add_executable(qe_phonon_dynmat_exe ${src_dynmat_x})
set_target_properties(qe_phonon_dynmat_exe PROPERTIES OUTPUT_NAME dynmat.x)
target_link_libraries(qe_phonon_dynmat_exe
    PRIVATE
        qe_lr_modules
        qe_modules
        qe_phonon_ph
        qe_phonon_phaux
        qe_fox)

###########################################################
# q2r.x
###########################################################
set(src_q2r_x PH/q2r.f90)
qe_add_executable(qe_phonon_q2r_exe ${src_q2r_x})
set_target_properties(qe_phonon_q2r_exe PROPERTIES OUTPUT_NAME q2r.x)
target_link_libraries(qe_phonon_q2r_exe
    PRIVATE
        qe_modules
        qe_phonon_ph)

###########################################################
# dvscf_q2r.x
###########################################################
set(src_dvscf_q2r_x PH/dvscf_q2r.f90)
qe_add_executable(qe_phonon_dvscf_q2r_exe ${src_dvscf_q2r_x})
set_target_properties(qe_phonon_dvscf_q2r_exe PROPERTIES OUTPUT_NAME dvscf_q2r.x)
target_link_libraries(qe_phonon_dvscf_q2r_exe
    PRIVATE
        qe_pw
        qe_lr_modules
        qe_modules
        qe_fftx
        qe_lapack
        qe_phonon_ph)

##################################################################
# matdyn.x 
##################################################################
set(src_matdyn_x PH/matdyn.f90)
qe_add_executable(qe_phonon_matdyn_exe ${src_matdyn_x})
set_target_properties(qe_phonon_matdyn_exe PROPERTIES OUTPUT_NAME matdyn.x) 
target_link_libraries(qe_phonon_matdyn_exe
    PRIVATE
        qe_modules
        qe_pw
        qe_phonon_ph
        qe_phonon_phaux
        qe_lr_modules)

###########################################################
# q2qstar.x
###########################################################
set(src_q2qstar_x PH/q2qstar.f90)
qe_add_executable(qe_phonon_q2qstar_exe ${src_q2qstar_x})
set_target_properties(qe_phonon_q2qstar_exe PROPERTIES OUTPUT_NAME q2qstar.x)
target_link_libraries(qe_phonon_q2qstar_exe
    PRIVATE
        qe_pw
        qe_lr_modules
        qe_modules
        qe_phonon_ph)

###########################################################
# lambda.x
###########################################################
set(src_lambda_x PH/lambda.f90)
qe_add_executable(qe_phonon_lambda_exe ${src_lambda_x})
set_target_properties(qe_phonon_lambda_exe PROPERTIES OUTPUT_NAME lambda.x)
target_link_libraries(qe_phonon_lambda_exe
    PRIVATE
        qe_modules
        qe_phonon_ph)

###########################################################
# alpha2f.x
###########################################################
set(src_alpha2f_x PH/alpha2f.f90)
qe_add_executable(qe_phonon_alpha2f_exe ${src_alpha2f_x})
set_target_properties(qe_phonon_alpha2f_exe PROPERTIES OUTPUT_NAME alpha2f.x)
target_link_libraries(qe_phonon_alpha2f_exe
    PRIVATE
        qe_openacc_fortran
        qe_pw
        qe_modules
        qe_phonon_ph)

###########################################################
# epa.x
###########################################################
set(src_epa_x PH/epa.f90)
qe_add_executable(qe_phonon_epa_exe ${src_epa_x})
set_target_properties(qe_phonon_epa_exe PROPERTIES OUTPUT_NAME epa.x)
target_link_libraries(qe_phonon_epa_exe
    PRIVATE
        qe_modules
        qe_phonon_ph)

###########################################################
# fqha.x
###########################################################
set(src_fqha_x PH/fqha.f90)
qe_add_executable(qe_phonon_fqha_exe ${src_fqha_x})
set_target_properties(qe_phonon_fqha_exe PROPERTIES OUTPUT_NAME fqha.x)
target_link_libraries(qe_phonon_fqha_exe
    PRIVATE
        qe_utilx
        qe_phonon_ph)

###########################################################
# postahc.x
###########################################################
set(src_postahc_x PH/postahc.f90)
qe_add_executable(qe_phonon_postahc_exe ${src_postahc_x})
set_target_properties(qe_phonon_postahc_exe PROPERTIES OUTPUT_NAME postahc.x)
target_link_libraries(qe_phonon_postahc_exe
    PRIVATE
        qe_modules
        qe_pw
        qe_lr_modules
        qe_phonon_ph)

###########################################################
# phcg.x
###########################################################
set(src_phonon_phcg_x Gamma/phcg.f90)
qe_enable_cuda_fortran("${src_phonon_phcg_x}")
qe_add_executable(qe_phonon_phcg_exe ${src_phonon_phcg_x})
set_target_properties(qe_phonon_phcg_exe PROPERTIES OUTPUT_NAME phcg.x)
target_link_libraries(qe_phonon_phcg_exe
    PRIVATE
        qe_pw
        qe_fftx
        qe_xclib
        qe_lr_modules
        qe_phonon_gamma
        qe_modules)

###########################################################
# fd.x
###########################################################
set(src_fd_x FD/fd.f90)
qe_add_executable(qe_phonon_fd_exe ${src_fd_x})
set_target_properties(qe_phonon_fd_exe PROPERTIES OUTPUT_NAME fd.x)
target_link_libraries(qe_phonon_fd_exe
    PRIVATE
        qe_pw
        qe_modules
        qe_phonon_fd
        qe_phonon_ph
        qe_fftx)

###########################################################
# fd_ef.x
###########################################################
set(src_fd_ef_x FD/fd_ef.f90)
qe_add_executable(qe_phonon_fdef_exe ${src_fd_ef_x})
set_target_properties(qe_phonon_fdef_exe PROPERTIES OUTPUT_NAME fd_ef.x)
target_link_libraries(qe_phonon_fdef_exe
    PRIVATE
        qe_pw
        qe_modules
        qe_phonon_fd
        qe_phonon_ph
        qe_fftx)

###########################################################
# fd_ifc.x

=== PIOUD/CMakeLists.txt ===
set(src_pioud
src/compute_scf_pioud.f90
src/engine_to_trpmd_pos.f90
src/engine_to_trpmd_nat_alat.f90
src/fcp_opt_routines.f90
src/fcp_variables.f90
src/trpmd_base.f90
src/ring_formats.f90
src/pw_gen_inputs.f90
src/ring_input_parameters_module.f90
src/trpmd_io_routines.f90
src/ring_io_units_module.f90
src/pimd_variables.f90
src/ring_variables.f90
src/pimd_subrout.f90
src/pimd_utils.f90
src/set_defaults.f90
src/stop_run_path.f90
)

qe_add_library(qe_pioud ${src_pioud})
target_link_libraries(qe_pioud
    PRIVATE
        qe_pw
        qe_lr_modules
        qe_modules
        qe_fftx
        qe_upflib
        qe_xclib)

###########################################################
# pioud.x
###########################################################
set(src_pioud_x src/pioud.f90)
qe_enable_cuda_fortran("${src_pioud_x}")
qe_add_executable(qe_pioud_exe ${src_pioud_x})
set_target_properties(qe_pioud_exe 
    PROPERTIES 
        OUTPUT_NAME pioud.x)
target_link_libraries(qe_pioud_exe
    PRIVATE
        qe_pw
        qe_lax
        qe_modules
        qe_pioud
        qe_xclib)

###########################################################

qe_install_targets(
    qe_pioud
    qe_pioud_exe)

add_custom_target(pioud
    DEPENDS
        qe_pioud_exe
    COMMENT
        "Path Integral Molecular Dynamics with PIOUD algorithm")

=== PIOUD/Makefile ===
# Makefile for PIOUD
sinclude ../make.inc

default: all

all:
	if test -d src ; then \
	( cd src ; $(MAKE) || exit 1 ) ; fi

clean : examples_clean
	if test -d src ; then \
	( cd src ; $(MAKE) clean ) ; fi

examples_clean:
	if test -d examples ; then \
	( cd examples ; ./clean_all ) ; fi 

distclean: clean doc_clean

=== TDDFPT/CMakeLists.txt ===
set(src_tddfpt
    src/environ_td_module.f90
    src/lr_variables.f90
    src/lr_charg_resp.f90
    src/bcast_lr_input.f90
    src/lr_readin.f90
    src/lr_alloc_init.f90
    src/lr_calc_dens.f90
    src/lr_dealloc.f90
    src/lr_ortho.f90
    src/lr_read_wf.f90
    src/lr_normalise.f90
    src/lr_lanczos.f90
    src/lr_apply_liouvillian.f90
    src/lr_dv_setup.f90
    src/lr_compute_intq.f90
    src/lr_set_intq_nc.f90
    src/lr_transform_intq_nc.f90
    src/lr_transform_intq_so.f90
    src/lr_solve_e.f90
    src/lr_dvpsi_e.f90
    src/stop_lr.f90
    src/lr_read_d0psi.f90
    src/lr_restart.f90
    src/lr_write_restart.f90
    src/print_clock_lr.f90
    src/sd0psi.f90
    src/lr_set_boxes_density.f90
    src/lr_init_nfo.f90
    src/lr_exx_kernel.f90
    src/lr_calc_dens_eels.f90
    src/lr_calc_dens_eels_nc.f90
    src/lr_apply_liouvillian_eels.f90
    src/lr_addus_dvpsi.f90
    src/lr_run_nscf.f90
    src/lr_setup_nscf.f90
    src/lr_sym_eels.f90
    src/lr_smallgq.f90
    src/lr_psym_eels.f90
    src/lr_summary.f90
    src/lr_dvpsi_eels.f90
    src/lr_dav_variables.f90
    src/lr_dav_routines.f90
    src/lr_us.f90
    src/lr_test_restart.f90
    src/plugin_tddfpt_potential.f90
    src/lr_sternheimer.f90
    src/linear_solvers.f90
    src/paw_add_symmetry.f90
    src/dveqpsi_us.f90
    src/dveqpsi_us_only.f90
    src/orthogonalize_omega.f90
    src/lr_mix_pot.f90
    src/lr_magnons_routines.f90
    src/lr_apply_liouvillian_magnons.f90
    src/lr_dvpsi_magnons.f90
    src/lr_Opsi_magnons.f90
    src/lr_calc_dens_magnons.f90)
qe_enable_cuda_fortran("${src_tddfpt}")


qe_add_library(qe_tddfpt ${src_tddfpt})
target_link_libraries(qe_tddfpt
    PRIVATE
        qe_hdf5_fortran
        qe_openmp_fortran
        qe_openacc_fortran
        qe_mpi_fortran
        qe_lr_modules
        qe_pw
        qe_modules
        qe_upflib
        qe_fftx
        qe_xclib)

###########################################################
# turbo_lanczos.x
###########################################################
set(src_turbo_lanczos_x src/lr_main.f90)
qe_enable_cuda_fortran("${src_turbo_lanczos_x}")
qe_add_executable(qe_tddfpt_turbolanczos_exe ${src_turbo_lanczos_x})
set_target_properties(qe_tddfpt_turbolanczos_exe 
    PROPERTIES 
        OUTPUT_NAME turbo_lanczos.x)
target_link_libraries(qe_tddfpt_turbolanczos_exe
    PRIVATE
        qe_openacc_fortran
        qe_openmp_fortran
        qe_mpi_fortran
        qe_pw
        qe_modules
        qe_tddfpt
        qe_upflib
        qe_fftx
        qe_xclib)

###########################################################
# turbo_davidson.x
###########################################################
set(src_turbo_davidson_x src/lr_dav_main.f90)
qe_enable_cuda_fortran("${src_turbo_davidson_x}")
qe_add_executable(qe_tddfpt_turbodavidson_exe ${src_turbo_davidson_x})
set_target_properties(qe_tddfpt_turbodavidson_exe 
    PROPERTIES 
        OUTPUT_NAME turbo_davidson.x)
target_link_libraries(qe_tddfpt_turbodavidson_exe
    PRIVATE
        qe_openacc_fortran
        qe_openmp_fortran
        qe_mpi_fortran
        qe_pw
        qe_modules
        qe_tddfpt
        qe_upflib
        qe_fftx
        qe_xclib)

###########################################################
# turbo_eels.x
###########################################################
set(src_turbo_eels_x src/lr_eels_main.f90)
qe_enable_cuda_fortran("${src_turbo_eels_x}")
qe_add_executable(qe_tddfpt_turboeels_exe ${src_turbo_eels_x})
set_target_properties(qe_tddfpt_turboeels_exe 
    PROPERTIES 
        OUTPUT_NAME turbo_eels.x)
target_link_libraries(qe_tddfpt_turboeels_exe
    PRIVATE
        qe_openacc_fortran
        qe_openmp_fortran
        qe_mpi_fortran
        qe_pw
        qe_lax
        qe_modules
        qe_tddfpt
        qe_lr_modules
        qe_upflib
        qe_fftx
        qe_xclib)

###########################################################
# turbo_magnon.x
###########################################################
set(src_turbomagnon_x src/lr_magnons_main.f90)
# Because this main file includes laxlib.fh which is preprocessed with __CUDA definition
# the main file needs to be compiled with consistent definitions.
qe_enable_cuda_fortran(src/lr_magnons_main.f90)
qe_add_executable(qe_tddfpt_turbomagnon_exe ${src_turbomagnon_x})
set_target_properties(qe_tddfpt_turbomagnon_exe
    PROPERTIES
        OUTPUT_NAME turbo_magnon.x)
target_link_libraries(qe_tddfpt_turbomagnon_exe
    PRIVATE
        qe_openacc_fortran
        qe_openmp_fortran
        qe_mpi_fortran
        qe_tddfpt
        qe_lr_modules
        qe_pw
        qe_lax
        qe_modules
        qe_fftx)

###########################################################
# turbo_spectrum.x
###########################################################
set(src_tddfpt_turbospectrum_x src/turbo_spectrum.f90)
qe_add_executable(qe_tddfpt_turbospectrum_exe ${src_tddfpt_turbospectrum_x})
set_target_properties(qe_tddfpt_turbospectrum_exe
    PROPERTIES
        OUTPUT_NAME turbo_spectrum.x)
target_link_libraries(qe_tddfpt_turbospectrum_exe
    PRIVATE
        qe_modules
        qe_xclib
        qe_lapack)

###########################################################

set(TDDFPT_EXE_TARGETS
    qe_tddfpt_turbolanczos_exe
    qe_tddfpt_turbodavidson_exe
    qe_tddfpt_turboeels_exe
    qe_tddfpt_turbomagnon_exe
    qe_tddfpt_turbospectrum_exe)

qe_install_targets(
    # Libraries
    qe_tddfpt
    # Executables
    ${TDDFPT_EXE_TARGETS})

add_custom_target(tddfpt
    DEPENDS
        ${TDDFPT_EXE_TARGETS}
    COMMENT
        "time dependent dft code")

=== test-suite/Makefile ===

#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include ./ENVIRONMENT

default :
	@echo 'To run Quantum ESPRESSO test-suite, type at the shell prompt:'
	@echo ' '
	@echo '  make target'
	@echo ' '
	@echo 'where <target> identifies an action'
	@echo ' run-tests-XX [NPROCS=N NBGRP=M]  : run tests [optionally, on N processors and M band groups]'
	@echo ' for XX=pw, cp, ph, pp, hp, tddfpt, kcw, all_currents, epw, zg, xsd-pw'
	@echo ' run-tests [NPROCS=N]             : run all tests above (except the last four)'
	@echo ' run-custom-test testdir=DIR [NPROCS=N NBGRP=M]: run test in DIR only'
	@echo ' compare                          : compare last output with reference'
	@echo ' pseudo                           : download needed PPs into ESPRESSO_PSEUDO'
	@echo ' clean                            : clean stdout/sderr of all tests'
	@echo ' '
	@echo 'For additional advanced commands and settings please manually inspect'
	@echo 'ENVIRONMENT and Makefile files'
	@echo 'NBGRP is ignored if NPROCS is not set'

prolog :
	@sed "s|XXXXXX|$(ESPRESSO_ROOT)|g" < userconfig.tmp > userconfig
	@if ! test -d $(ESPRESSO_TMPDIR); then mkdir $(ESPRESSO_TMPDIR); fi

pseudo :
	@./check_pseudo.sh pw_
	@./check_pseudo.sh cp_
	@./check_pseudo.sh epw_
	@./check_pseudo.sh tddfpt_
	@./check_pseudo.sh hp_
	@./check_pseudo.sh ph_
	@./check_pseudo.sh QEHeat_
	@./check_pseudo.sh kcw_
	@./check_pseudo.sh oscdft_

run-tests : run-tests-pw run-tests-cp run-tests-ph run-tests-pp run-tests-hp run-tests-tddfpt run-tests-kcw run-tests-pioud

run-tests-cp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=cp_all

run-tests-pw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) env QE_USE_BGRP=$(NBGRP) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pw_all

run-tests-ph : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=ph_all

run-tests-epw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_all

run-tests-zg : prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=zg_all

run-tests-hp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=hp_all

run-tests-pp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pp_all

run-tests-tddfpt : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=tddfpt_all

run-tests-image : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=image_all

run-tests-kcw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose  --category=kcw_all

run-tests-all_currents : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=all_currents_all

run-tests-oscdft : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=oscdft_all

run-tests-pioud : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pioud_all

run-travis : clean prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_base

run-custom-test : prolog pseudo
	@if test -d $(testdir); then \
	env QE_USE_MPI=$(NPROCS) env QE_USE_BGRP=$(NBGRP) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=$(testdir) ; fi

run-tests-xsd-pw : prolog pseudo
	cd xsd_pw ; for file in ./*.in ; do \
	echo "Running using $$file" ; \
		env QE_USE_MPI=$(NPROCS) ../run-pw.sh -in $$file &> $$file.out ; \
		python ../validate_xsd_pw.py $$file; \
    done ; cd ..

create-reference-cp : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=cp_all make-benchmarks

create-reference-pw : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=pw_all make-benchmarks

create-reference-epw : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=epw_all make-benchmarks

create-reference-all_currents : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=all_currents_all make-benchmarks

create-reference-oscdft : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=oscdft_all make-benchmarks

compare : compare-cp compare-pw compare-ph compare-epw compare-tddfpt compare-hp compare-all_currents

compare-cp : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=cp_all  --verbose compare 2>&1 | tee out.CP.`date +%Y%m%d_%H%M%S`

compare-pw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=pw_all  --verbose compare 2>&1 | tee out.PW.`date +%Y%m%d_%H%M%S`

compare-ph : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=ph_all  --verbose compare 2>&1 | tee out.PH.`date +%Y%m%d_%H%M%S`

compare-epw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=epw_all  --verbose compare 2>&1 | tee out.EPW.`date +%Y%m%d_%H%M%S`

compare-tddfpt : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=tddfpt_all  --verbose compare 2>&1 | tee out.TDDFPT.`date +%Y%m%d_%H%M%S`

compare-hp : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=hp_all  --verbose compare 2>&1 | tee out.HP.`date +%Y%m%d_%H%M%S`

compare-all_currents : prolog pseudo
	${TESTCODE_DIR}/bin/testcode.py --category=all_currents_all  --verbose compare 2>&1 | tee out.ALL_CURRENTS.`date +%Y%m%d_%H%M%S`


clean:
# output files
	@rm -rf pw_*/test* ph_*/test* cp_*/test* hp_*/test* pp_*/test* epw_*/test* zg_*/test* tddfpt_*/test* kcw_*/test*
# error files
	@rm -rf pw_*/CRASH ph_*/CRASH* cp_*/CRASH hp_*/CRASH pp_*/CRASH epw_*/CRASH zg_*/CRASH tddfpt_*/CRASH kcw_*/CRASH
# temporary input files
	@rm -rf pw_*/input_tmp.in ph_*/input_tmp.in cp_*/input_tmp.in hp_*/input_tmp.in pp_*/input_tmp.in epw_*/input_tmp.in zg_*/input_tmp.in tddfpt_*/input_tmp.in kcw_*/input_tmp.in
# pwscf data files
	@rm -rf pw_*/pwscf.* ph_*/pwscf.* pp_*/pwscf.* epw_*/pwscf.*
# cp data files
	@rm -rf cp_si/si_*.* cp_o2/o2_*.* cp_h2o*/h2o_*.* cp_sio2/sio2_*.*
	@rm -rf cp_si/si.??? cp_o2/o2.??? cp_h2o*/h2o.??? cp_sio2/sio2.???
# Special case for 'pw_vc-relax' test-case
	@rm -f pw_vc-relax/ave pw_vc-relax/e pw_vc-relax/tv pw_vc-relax/p pw_vc-relax/eal pw_vc-relax/avec
# Special case for 'noexe_langevin' test-case
	@rm -f noexe_langevin/trajectory-pwscf.xyz
# Special case for PH
	@for x in `find ph_* -name "*dyn"`; do rm -rf $$x; done
# Cleaning PH final files
	@rm -rf ph_*/_ph0 ph_*/*.save ph_*/*.xml ph_*/a2F.* ph_*/*.dyn? ph_*/*.dyn?? ph_*/alpha2F.dat \
		ph_*/dyna2F ph_*/elph.gamma* ph_*/gam.lines ph_*/lambda ph_*/lambda.dat \
		ph_*/elph_dir ph_*/Al444.* ph_*/matdyn.modes ph_*/phonon.dos
	@rm -rf ph_metal/aluminum.* ph_base/carbon.* ph_base/nickel.* ph_base/nickelpaw.* ph_base/silicon.* \
	        ph_U_metal_us/iron.* ph_U_insulator_us/bn.* ph_U_metal_paw/nickel.* ph_U_insulator_paw/bn.*
	@rm -rf ph_*/*.wfc* ph_*/*.hub*
	@rm -rf ph_1d/dynmat.axsf ph_1d/dynmat.mold
	@rm -rf ph_2d/bn.frc ph_2d/bn.frq ph_2d/bn.frq.gp
	@rm -rf ph_twochem/dynq1
	@rm -rf ph_multipole/*npz ph_multipole/*fmt ph_multipole/*dat* ph_multipole/*pkl ph_multipole/*processing*
# Special case for PH dvscf_q2r
	@rm -rf ph_interpol*/w_pot/ ph_interpol*/*.dyn*.elph.* ph_interpol*/*.dyn.freq
# Special case for PH ahc
	@rm -rf ph_ahc*/wpot*/ ph_ahc*/selfen_*.dat ph_ahc_diam/diam.modes? ph_ahc_bas/BAs.modes? ph_ahc*/*.ifc \
		ph_ahc*/*.fc ph_ahc*/ahc_dir*
# Cleaning HP final files
	@rm -rf hp_*/HP hp_*/*hub* hp_*/*.xml hp_*/*.wfc* hp_*/*.save hp_*/*Hubbard_parameters* \
		hp_*/*HubbardV* hp_*/*mix* hp_*/*parameters.out
# Cleaning KCW final files
	@rm -rf	kcw_*/out kcw_*/*.nnkp kcw_*/*.wout kcw_*/*.amn kcw_*/*.mmn kcw_*/*.eig kcw_*/*band* kcw_*/*chk \
                kcw_*/*.dat kcw_*/*.xyz kcw_*/*.mat 
# Cleaning EPW final files
	@rm -rf epw_*/_ph0 epw_*/*.save epw_*/*.wfc* epw_*/*.dyn* \
		epw_*/*.qdos_* epw_*/*.P epw_*/*.wout epw_*/crystal.fmt epw_*/*.pade* \
		epw_*/*.epmat_wanep epw_*/*.kgmap epw_*/*.nnkp epw_*/*.epmatwp* \
		epw_*/*.acon_iso_* epw_*/*.a2f* epw_*/*.phdos* epw_*/*.lambda \
		epw_*/*.kmap epw_*/*.lambda_k_pairs epw_*/*.ukk epw_*/*.imag_aniso* \
		epw_*/*.win epw_*/*.imag_iso* epw_*/*.chk epw_*/*.freq  \
		epw_*/*.epmatwp epw_*/*.epwane epw_*/*.ephmat epw_*/epsilon2* \
		epw_*/*.H epw_*/*.epb* epw_*/*self epw_*/*.res* epw_*/*.01 \
		epw_*/*.kpt epw_*/*.gnu epw_*/*.lambda_FS epw_*/*.sigma_restart* \
		epw_*/specfun* epw_*/linewidth.*  epw_*/*.tau_restart* epw_*/lambda.phself* \
		epw_*/*_elcond_* epw_*/fort.* epw_*/decay.* epw_*/scattering_rate* \
		epw_*/*.fc.* epw_*/*_band.dat epw_*/*F_restart* epw_*/*F_restart_CB* \
		epw_*/*.mmn epw_*/*.epmatkq* epw_*/*.epmatkqcb* epw_*/sparse* \
		epw_*/*.Fin_restart* epw_*/*.Fin_restartcb* epw_*/*.acon_iso_* \
		epw_*/*.bvec epw_*/*.fc epw_*/*.xml epw_*/*.labelinfo.dat \
		epw_*/Fepmatkq1* epw_*/Fepmatkqcb1* epw_*/Fsparse* epw_*/Fsparsecb* \
		epw_*/*.cube epw_*/EPW.bib \
		epw_*/*_hr.dat epw_*/*_wsvec.dat epw_*/epwdata.fmt epw_*/IBTEvel_sup*.fmt \
		epw_*/restart*.fmt epw_*/vmedata.fmt \
		epw_*/selecq.fmt epw_*/dmedata.fmt epw_*/band.eig epw_*/ksdata.fmt \
		epw_*/mobility_nk.fmt epw_*/mobility_nuq.fmt epw_*/inv_tau* \
		epw_*/wigner.fmt epw_*/*.dos epw_*/*.dmat* epw_*/*.qmap epw_*/*.dwmatwe* \
		epw_*/*.symk epw_*/*.sthmatwe* epw_*/*.xqc* epw_*/*.dgmatwe* epw_*/*.cpmew* \
		epw_*/elself_wfpt_sup.* epw_*/*.bak epw_*/out.*

# Special cases for EPW
	@rm -rf epw_base/save epw_super/save epw_super/*.bands.*.dat epw_pl/save/ epw_polar/save/ \
		epw_trev/save epw_trev_uspp/save epw_trev_paw/save \
		epw_mob/save epw_mob_ibte/save epw_mob_ibte_sym/save epw_mob_polar/save \
		epw_qdpt/save epw_2D/save epw_hall/save epw_qdpt/*.dat epw_wfpt/save \
		epw_wfpt/matdyn.modes epw_plrn/*.plrn epw_plrn/plrn_tmp epw_plrn/save \
		epw_plrn/dtau.plrn.xsf epw_tdbe/ie_ph.dat epw_tdbe/iph_e.dat          \
		epw_tdbe/felec epw_tdbe/nphon epw_tdbe/*points epw_tdbe/selecq_tdbe.fmt \
	        epw_tdbe/inv_tau_rta* epw_tdbe/ph_freq epw_tdbe/save

# Cleaning IMAGE final files
	@rm -rf image_*/_ph0 image_*/*.save image_*/*.xml image_*/*.dyn? image_*/*.dyn??  \
                image_*/*.wfc*

# Cleaning ZG final files
	@rm -f zg_conf/equil_pos.txt zg_conf/ZG-*_0.020.dat

# Cleaning TDDFPT final files
	@rm -rf tddfpt_*/*.plot_chi.dat tddfpt_*/*.plot_eps.dat tddfpt_*/out/ tddfpt_*/turbo_spectrum.out
# Cleaning OS-CDFT final files
	@rm -rf oscdft_*/*.out oscdft_*/*.save oscdft_*/*.xml oscdft_*/test* oscdft_*/*.md oscdft_*/*.bfgs oscdft_*/*.mix* oscdft_*/*.wfc* oscdft_*/oscdft.in oscdft_*/*.tmp
# all_currents files
	@for x in `find QEHeat_* -name "test*"`; do rm -rf $$x; done
	@for x in `find QEHeat_* -name "CRASH"`; do rm -rf $$x; done
	@rm -rf QEHeat_*/save \
                QEHeat_*/current_hz*
	@rm -f userconfig


# Calling 'purge' means remove all reference outputs... be careful!
purge: clean
	@for x in `find pw_* -name "benchmark*"`; do rm -rf $$x; done
	@for x in `find cp_* -name "benchmark*"`; do rm -rf $$x; done
	@for x in `find QEHeat_* -name "benchmark*"`; do rm -rf $$x; done


run-tests-serial : run-tests-pw-serial run-tests-cp-serial run-tests-ph-serial run-tests-epw-serial run-tests-hp-serial run-tests-tddfpt-serial run-tests-kcw-serial
	@echo '$@ obsolete, use "make run-tests" instead'
run-tests-pw-serial : run-tests-pw
	@echo '$@ obsolete, use "make run-tests-pw" instead'
run-tests-cp-serial : run-tests-cp
	@echo '$@ obsolete, use "make run-tests-cp" instead'
run-tests-ph-serial : run-tests-ph
	@echo '$@ obsolete, use "make run-tests-ph" instead'
run-tests-epw-serial : run-tests-epw
	@echo '$@ obsolete, use "make run-tests-epw" instead'
run-tests-hp-serial : run-tests-hp
	@echo '$@ obsolete, use "make run-tests-hp" instead'
run-tests-tddfpt-serial : run-tests-tddfpt

=== upflib/Makefile ===
# Makefile for upflib

include ../make.inc

MODFLAGS= $(MOD_FLAG)../UtilXlib $(MOD_FLAG).

# list of modules:
# OBJS_NODEP do not depend upon any external modules
# OBJS_DEP   depend upon modules in UtilXlib/
# OBJS_GPU   are GPU-specific

OBJS_DEP= \
atwfc_mod.o \
beta_mod.o \
qrad_mod.o  \
rhoat_mod.o \
rhoc_mod.o \
vloc_mod.o \
qvan2.o \
dqvan2.o \
gen_us_dj.o \
gen_us_dy.o \
init_us_0.o \
init_us_b0.o \
init_us_1.o \
init_us_2_acc.o

OBJS_NODEP= \
atom.o \
atomic_number.o \
dylmr2.o \
gth.o \
paw_variables.o \
pseudo_types.o \
radial_grids.o \
read_cpmd.o \
read_fhi.o \
read_ncpp.o \
read_ps.o \
read_psml.o \
read_upf_new.o \
read_upf_v1.o \
read_uspp.o \
spinor.o \
sph_ind.o \
sph_bes.o \
splinelib.o \
simpsn.o \
upf_auxtools.o \
upf_const.o \
upf_error.o \
upf_invmat.o \
upf_io.o \
upf_ions.o \
upf_kinds.o \
upf_params.o \
upf_parallel_include.o \
upf_spinorb.o \
upf_to_internal.o \
upf_utils.o \
uspp.o \
uspp_param.o \
write_upf_new.o \
xmltools.o \
ylmr2.o

# CUDA Fortran routines
OBJS_GPU= \
  ylmr2_gpu.o

OBJS_NODEP+= $(OBJS_GPU) dom.o wxml.o

all : libupf.a virtual_v2.x upfconv.x casino2upf.x

libupf.a: $(OBJS_DEP) $(OBJS_NODEP) $(OBJS_GPU)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

# The following utilities are linked with $(OBJS_NODEP) instead of libupf.a
# because the latter has external dependencies that produce "missing symbols"
# errors for some linkers that try to resolve symbols even if never used

virtual_v2.x : virtual_v2.o $(OBJS_NODEP)
	$(LD) $(LDFLAGS) -o $@ virtual_v2.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)

casino2upf.x : casino2upf.o casino_pp.o $(OBJS_NODEP)
	$(LD) $(LDFLAGS) -o $@ casino2upf.o casino_pp.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)
upfconv.x : upfconv.o casino_pp.o $(OBJS_NODEP) 
	$(LD) $(LDFLAGS) -o $@ upfconv.o casino_pp.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=quantum-espresso
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.5
pkgrel=1
#_d3q_commit=de4718351e7bbb9d1d12aad2b7ca232d06775b83
_devxlib_commit=a6b89ef77b1ceda48e967921f1f5488d2df9226d
_fox_commit=3453648e6837658b747b895bb7bef4b1ed2eac40
_pw2qmcpack_commit=f72ab25fa4ea755c1b4b230ae8074b47d5509c70
#_qe_gipaw_commit=490046d300ec23444504bfad0562baa1c71f9345
pkgdesc="opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='http://www.quantum-espresso.org/'
msys2_repository_url="https://gitlab.com/QEF/q-e"
msys2_references=(
  'aur: quantum-espresso'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libmbd"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-wannier90"
             #"${MINGW_PACKAGE_PREFIX}-environ"
             "git")
source=("https://gitlab.com/QEF/q-e/-/archive/qe-${pkgver}/q-e-qe-${pkgver}.tar.bz2"
        #"d3q::git+https://github.com/anharmonic/d3q#commit=${_d3q_commit}"
        "devxlib::git+https://gitlab.com/max-centre/components/devicexlib#commit=${_devxlib_commit}"
        "fox::git+https://github.com/pietrodelugas/fox#commit=${_fox_commit}"
        "pw2qmcpack::git+https://github.com/QMCPACK/pw2qmcpack#commit=${_pw2qmcpack_commit}"
        #"qe-gipaw::git+https://github.com/dceresoli/qe-gipaw#commit=${_qe_gipaw_commit}"
        "001-use-srand-instead-of-srandom.patch"
        "002-fix-build-devxlib-on-mingw.patch"
        "003-fix-install-c-libraries.patch"
        "004-fix-executable-suffix-on-mingw.patch")
sha256sums=('aba3ab4dd9e9ebc6611c6f3017b98a8f0e2be9455e356d85df84f9a36b844d98'
            'ef02c13a1ea73f38f0b81edd281c991c25bf045307ceb305f5c0f96b743d1556'
            '8625181b53f2b616a0f704507b4f2381f7b9fabe02078dfb74ab41ee11f5c260'
            'f0f5ebece3f0142e0d0b476db9547d8501de80259bc6409e9b108b887e4cc058'
            '2e18a13c194328516176c2bc2429ac230c9fc585381aa238e586b6034a7df0cb'
            'faaf147678e0c79a6678c5463dd5a466769257968275ef562f40ad1a0c2aacc6'
            '30f2fd93980f09baf07c810df1bcbd60594e54a156c5dae49a1888cf28619421'
            'a729ab4c6fc9e47baa05d4383568e271a5560c981e4bf0d9cb56a499c7d6e435')
noextract=("q-e-qe-${pkgver}.tar.bz2")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  echo "Extracting q-e-qe-${pkgver}.tar.bz2..."
  tar -xjf q-e-qe-${pkgver}.tar.bz2 || true

  for _ext_prj in devxlib fox pw2qmcpack; do
    mv ${_ext_prj} q-e-qe-${pkgver}/external/
  done

  cd "${srcdir}"/q-e-qe-${pkgver}
  apply_patch_with_msg \
    001-use-srand-instead-of-srandom.patch \
    002-fix-build-devxlib-on-mingw.patch \
    003-fix-install-c-libraries.patch \
    004-fix-executable-suffix-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS=" -Wno-missing-include-dirs -w"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DQE_ENABLE_FOX=ON \
      -DQE_ENABLE_HDF5=ON \
      -DQE_ENABLE_OPENMP=ON \
      -DQE_ENABLE_ENVIRON=OFF \
      -DQE_ENABLE_LIBXC=OFF \
      -DQE_ENABLE_MPI=OFF \
      -DQE_ENABLE_TEST=OFF \
      -DQE_ENABLE_PLUGINS="pw2qmcpack;legacy" \
      -DQE_DEVICEXLIB_INTERNAL=ON \
      -DQE_FOX_INTERNAL=ON \
      -DQE_MBD_INTERNAL=OFF \
      -DQE_WANNIER90_INTERNAL=OFF \
      -DQE_FFTW_VENDOR="FFTW3" \
      -DBLA_VENDOR=OpenBLAS \
      -S q-e-qe-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/q-e-qe-${pkgver}/License \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/qe/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Rename cp to qe_cp, to not be used instead of /usr/bin/cp to copy files
  mv "${pkgdir}${MINGW_PREFIX}"/bin/{cp,qe_cp}.exe
}
